#ifndef EDITOR_VIEW_H
#define EDITOR_VIEW_H

#include "day.h"
#include "MainView.h"


#define BUTTON_ADD_GRP 'adgr'
#define BUTTON_DEL_GRP 'degr'
#define BUTTON_EDT_GRP 'edtr'

#define BUTTON_ADD_POL 'adpl'
#define BUTTON_DEL_POL 'depl'
#define BUTTON_EDT_POL 'edpl'

#define BUTTON_GEN 'gnar'

#define BUTTON_DONE 'btdn'

#define SET_GRP_LIST_EDIT 'stls'
#define SET_POL_LIST_EDIT 'sple'


#define BUTTON_NEXT 'btnx'
#define BUTTON_PREV 'btpv'



#define FLAG_LOAD  'flgl'

#define SET_COMPUTER_PLAYER 'stcp'
#define SET_PLAYER_01 		'stp1'
#define SET_PLAYER_02 		'stp2'
#define SET_PLAYER_03 		'stp3'
#define SET_PLAYER_04 		'stp4'
#define SET_PLAYER_05 		'stp5'
#define SET_PLAYER_06 		'stp6'
#define SET_PLAYER_07 		'stp7'
#define SET_PLAYER_08 		'stp8'


//-------------------------------------------------------------------
//-------------------------------------------------------------------
class	EditorView : public BView {
public:
		EditorView(BRect r, long flags,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur);
virtual	~EditorView();

void		MouseDown(BPoint where);
	

		BButton *button_Next, *button_Prev, *button_Gen;		
		void SetEdit();    //met les valeurs actuelles dans les cases
		void UpdateEdit(); //update les valeurs avec celles des cases
		void UpdateGroups();
		void SelectedCt();

		BListView *list,*ct_list; //pour groupes
		day		*jour;
		Country **Ct_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Group **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Politic **Pol_pointer;	 //utilisé par les sous-fonctions type MouseDown

		BStringView  *numero;
		
		BTextControl *money_control, *birth_rate_control, *tech_level_control;
		BTextControl *pnb_control;
		BCheckBox    *sea_check,*nuke_check;
		
		BTextControl *name_control,*group_name_control,*population_control;
		BTextControl *infantry_control, *tank_control, *marine_control;
		BTextControl *airforce_control, *missile_control,*nuke_control,*dca_control; 

	 	BButton *button_AddGrp,*button_DelGrp,*button_EdtGrp;

		

};

////-------------------------------------------------------------------------------------
class	FlagView : public BView {
public:
		FlagView(BRect r, long flags,Group *Group_id[MAX_GROUP], day *compteur);

void		MouseDown(BPoint point);

		day		*jour;
		Group **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		
virtual	void		Draw(BRect);

};

////-------------------------------------------------------------------------------------
class	ChooseView : public BView {
public:
		ChooseView(BRect r, long flags,Group *Group_id[MAX_GROUP], day *compteur);
virtual	~ChooseView();

		FlagView *le_fond_choose;

		BBitmap     *title;



		day		*jour;
		Group **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		
virtual	void		Draw(BRect);

};

//-------------------------------------------------------------------------------------

class	EditorPolView : public BView {
public:
		EditorPolView(BRect r, long flags,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur);

		day		*jour;
		Country **Ct_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Group   **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Politic **Pol_pointer;	 //utilisé par les sous-fonctions type MouseDown
		
		BTextControl *pol_name_control;
		BSlider *slider_repression,*slider_propaganda; 

BMenuField *pol_relation[MAX_POLITIC];
BView* le_fond_pol;
BScrollView *sc_view;

void	UpdatePolEdit();
void	SetPolEdit();
void    SetPolitic();
	
};
//-------------------------------------------------------------------------------------

class	EditorGrpView : public BView {
public:
		EditorGrpView(BRect r, long flags,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur);

		BListView *pol_list; //pour groupes
		day		*jour;
		Country **Ct_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Group   **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Politic **Pol_pointer;	 //utilisé par les sous-fonctions type MouseDown
		
		BTextControl *name_control;

		rgb_color coul;
		BColorControl *col_control;
void	 UpdateGrpEdit();
void	 SetGrpEdit();
void	 UpdatePolitics();

	 	BButton *button_AddPol,*button_DelPol,*button_EdtPol;

		BStringView  *nom_file;
		BMenuField *player;
virtual	void		Draw(BRect);

};
#endif
