#include "InfoWindow.h" 



TxtView::TxtView(BRect rect, const char *name, const char *text)
	   	   : BStringView(rect, name, text, B_FOLLOW_TOP | B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW)
{
	SetFont(be_bold_font);
	SetFontSize(12);
	SetHighColor(255,255,255);
	SetAlignment(B_ALIGN_CENTER);
}


BarView::BarView(BRect r, const char *nm,float lm, const char* l_text) :
	BView(r, "", B_FOLLOW_TOP | B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW)
{
 	percentage = 100;
 	limit = lm;
 	sprintf(name,nm);
 	sprintf(limit_text,l_text);
}


void BarView::Draw(BRect update_rect)
{
	//cadre
	BRect r = Bounds();
	SetHighColor(255,255,255);
	FillRect(r,B_SOLID_HIGH);
	
	r.right-=1;
	r.bottom-=1;
	SetHighColor(140,140,140);
	FillRect(r,B_SOLID_HIGH);
	
	//fond noir
	r.left+=1;
	r.top+=1;
	SetHighColor(0,0,0);
	FillRect(r,B_SOLID_HIGH);

	//fond pourcentage
	r.right = r.right * percentage / 100;
	if (percentage > limit) SetHighColor(0,160,0); //couleur normale
		else SetHighColor(150,30,0); //Couleur limite atteinte
	FillRect(r,B_SOLID_HIGH);
	
	char str[255];
	char str2[255];
	sprintf(str,name);
	sprintf(str2,": %.3g %%",percentage);
	strcat(str,str2);
	
	SetFont(be_bold_font);
	SetFontSize(9);
	
	if (percentage <= limit) strcat(str,limit_text);

	float lg = StringWidth(str);
	BPoint pt( (Bounds().Width()/2)-lg/2,
			   (Bounds().Height()/2)+4);

	SetDrawingMode(B_OP_BLEND);
	SetHighColor(0,0,0); 		DrawString(str,pt);

	SetDrawingMode(B_OP_ADD);
	pt -= BPoint(1,1);
	SetHighColor(255,255,255);	DrawString(str,pt);
	
}
	

ColGrpView::ColGrpView(BRect r) :
	BView(r, "", B_FOLLOW_TOP, B_WILL_DRAW)
{
  hidden = true;
  
}

void ColGrpView::MouseMoved(BPoint point, uint32 transit, const BMessage *message)
{

	if (transit==B_ENTERED_VIEW) if (hidden==true) 
			{	
				point += BPoint(32,0);
				the_win->MoveTo(ConvertToScreen(point));
				the_win->Show(); hidden=false; }
	
	if (transit==B_EXITED_VIEW)   
			{ the_win->Hide(); hidden=true; }
}



		

GroupView::GroupView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur) :
	BView(r, "", B_FOLLOW_TOP, B_WILL_DRAW)
{
  
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
	


//----AFFICHAGE DES INFOS
    SetViewColor(0,0,0);
//------------------------


#define INF_TOP_TXT_B 65
#define INDENT 2 //bord gauche
unsigned char line_pos=0;

BRect rect;

line_pos=0;
rect.Set(INDENT,INF_TOP_TXT_B+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT_B);
grp_name_view = new TxtView(rect, "grp", "xxx");
AddChild(grp_name_view);

line_pos=1;
rect.Set(INDENT,INF_TOP_TXT_B+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT_B);
player_view = new TxtView(rect, "player_view", "xxx");
AddChild(player_view);



}





void	GroupView::Draw(BRect update_rect)
{
if (Grp_pointer[grp]->flag_ptr != NULL)
DrawBitmap(Grp_pointer[grp]->flag_ptr, BPoint(54,11));
else 
     {SetHighColor(100,100,100);
     FillRect(BRect(54,16,54+FLAG_X_SIZE-1,16+FLAG_Y_SIZE-1),B_SOLID_HIGH);
     }
}

void GroupView::UpdateGroupInfo(uint8 which_grp)
{
grp = which_grp;

Window()->Lock();
be_app->Lock();

	char str[255];
	char str2[255];
	
	
	rgb_color couleur_groupe = Grp_pointer[grp]->grp_color; //non il y pas de gestionnaire de café installé ;-)

//-------------------------------------------------------------------------------------
	//RVBA
	grp_name_view->SetHighColor(couleur_groupe); 
	//%G affiche que les virgules nécessaires
	sprintf(str,Grp_pointer[grp]->grp_name);
	sprintf(str2," (%.3g %%)",Grp_pointer[grp]->power_percent);
	strcat(str,str2);
	//pour arrondir vers le bas: floor(xxx)
	grp_name_view->SetText(str);

	sprintf(str,Pol_pointer[Grp_pointer[grp]->politic]->politic_name);
	
	switch(Grp_pointer[grp]->player)
	{
	case COMPUTER:	sprintf(str2,", (Computer)");	break;
	case PLAYER_01:	sprintf(str2,", (Player 1)");	break;
	case PLAYER_02:	sprintf(str2,", (Player 2)");	break;
	case PLAYER_03:	sprintf(str2,", (Player 3)");	break;
	case PLAYER_04:	sprintf(str2,", (Player 4)");	break;
	case PLAYER_05:	sprintf(str2,", (Player 5)");	break;
	case PLAYER_06:	sprintf(str2,", (Player 6)");	break;
	case PLAYER_07:	sprintf(str2,", (Player 7)");	break;
	case PLAYER_08:	sprintf(str2,", (Player 8)");	break;

	}
	strcat(str,str2);
	player_view->SetText(str);

	
	Draw(Bounds()); //pour le drapeau
//---------------------------------------------

Window()->Unlock();
be_app->Unlock();

}


TopView::TopView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur) :
	BView(r, "", B_FOLLOW_TOP, B_WILL_DRAW)
{
  
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
}


StatusView::StatusView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur) :
	BView(r, "", B_FOLLOW_TOP, B_WILL_DRAW )
{
  
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;
		
img_war 	= BTranslationUtils::GetBitmap('RAWT', 60, NULL);
img_peace 	= BTranslationUtils::GetBitmap('RAWT', 61, NULL);
}

void StatusView::Draw(BRect update_rect)
{
	if (Ct_pointer[jour->active_country]->war==ON) 
	{ 
		DrawBitmap(img_war,  BPoint(0,0)); 
		if (Ct_pointer[jour->active_country]->status!=FREE)
			 bb_help.SetHelp(this,"Status: war / occupied");
		else bb_help.SetHelp(this,"Status: war / free");
		
	}
	else
	{
		DrawBitmap(img_peace,  BPoint(0,0));
		if (Ct_pointer[jour->active_country]->status!=FREE)
			bb_help.SetHelp(this,"Status: peace / occupied");
			else bb_help.SetHelp(this,"Status: peace / free");
	}

}


WeatherView::WeatherView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur) :
	BView(r, "", B_FOLLOW_TOP, B_WILL_DRAW)
{
  
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id; 
	Pol_pointer = Politic_id;
		
//+-----------------------------------

img_very_dry		= BTranslationUtils::GetBitmap('RAWT', 70, NULL);
img_dry				= BTranslationUtils::GetBitmap('RAWT', 71, NULL);
img_normal_hum		= BTranslationUtils::GetBitmap('RAWT', 72, NULL);
img_rainy			= BTranslationUtils::GetBitmap('RAWT', 73, NULL);
img_very_rainy		= BTranslationUtils::GetBitmap('RAWT', 74, NULL);

img_very_cold		= BTranslationUtils::GetBitmap('RAWT', 80, NULL);
img_cold			= BTranslationUtils::GetBitmap('RAWT', 81, NULL);
img_normal_temp		= BTranslationUtils::GetBitmap('RAWT', 82, NULL);
img_hot				= BTranslationUtils::GetBitmap('RAWT', 83, NULL);
img_very_hot		= BTranslationUtils::GetBitmap('RAWT', 84, NULL);
	
}



void WeatherView::Draw(BRect update_rect)
{
	char str[255];
	char str2[255];
	
	//Weather (pour agriculture)
	switch (Ct_pointer[jour->active_country]->real_temperature)
	{
		case VERY_COLD: sprintf(str,"Very cold");	DrawBitmap(img_very_cold,  BPoint(0,0)); break;
		case COLD: sprintf(str,"Cold");				DrawBitmap(img_cold,  BPoint(0,0)); break;
		case MODERATE: sprintf(str,"Cool");			DrawBitmap(img_normal_temp,  BPoint(0,0)); break;
		case WARM: sprintf(str,"Warm");				DrawBitmap(img_hot,  BPoint(0,0)); break;
		case HOT: sprintf(str,"Hot");				DrawBitmap(img_very_hot,  BPoint(0,0)); break;
	}

	switch (Ct_pointer[jour->active_country]->real_weather)
	{
		case VERY_DRY: sprintf(str2," / Very Dry");		DrawBitmap(img_very_dry,  BPoint(10,0)); break;
		case DRY: sprintf(str2," / Dry");				DrawBitmap(img_dry,  BPoint(10,0)); break;
		case MODERATE: sprintf(str2," / Stable");		DrawBitmap(img_normal_hum,  BPoint(10,0)); break;
		case RAINY: sprintf(str2," / Rainy");			DrawBitmap(img_rainy,  BPoint(10,0)); break;
		case VERY_RAINY: sprintf(str2," / Very rainy");	DrawBitmap(img_very_rainy,  BPoint(10,0)); break;
	}
	
	strcat(str,str2);
	bb_help.SetHelp(this,str);

}






InfoView::InfoView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur) :
	BView(r, "", B_FOLLOW_ALL, B_WILL_DRAW )
{
  
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id;
	Pol_pointer = Politic_id;

 

//----AFFICHAGE DES INFOS
    SetViewColor(0,0,0);
//------------------------


BRect r;
r.Set(0,0,Bounds().Width()-2,100);
grpwin = new GroupWindow(r,Ct_pointer,Grp_pointer,Pol_pointer,jour);
grporiwin = new GroupWindow(r,Ct_pointer,Grp_pointer,Pol_pointer,jour);
grporiwin->Show();
grpwin->Show();

back_view = new TopView(BRect(0,0,Bounds().Width(),51), Ct_pointer,Grp_pointer,Pol_pointer,jour);
AddChild(back_view);

BRect yy(0,0,32-1,32-1);
yy.OffsetBy(84,6);
stat_view = new StatusView(yy, Ct_pointer,Grp_pointer,Pol_pointer,jour);

yy.OffsetBy(32+4,0);
wth_view = new WeatherView(yy, Ct_pointer,Grp_pointer,Pol_pointer,jour);
   	
back_view->AddChild(wth_view);	
back_view->AddChild(stat_view);	


BRect rect;

rect.Set(0,0,32-1,32-1);
rect.OffsetBy(6,6);

CreateButton(53,54);
buy_button = new BPictureButton(rect,"",on, off, new BMessage(BUTTON_BUY),B_ONE_STATE_BUTTON);


rect.OffsetBy(32+4,0);
CreateButton(51,52);
set_button = new BPictureButton(rect,"",on, off, new BMessage(BUTTON_SET),B_ONE_STATE_BUTTON);

bb_help.SetHelp(buy_button,"Buy army (B)");
bb_help.SetHelp(set_button,"Country settings (T)");

CreateButton(55,56); //create the pictures
buy_button ->SetDisabledOn(on); 
buy_button ->SetDisabledOff(on);
set_button ->SetDisabledOn(off); 
set_button ->SetDisabledOff(off); 

back_view->AddChild(buy_button);
back_view->AddChild(set_button);

BRect raaa;
raaa.Set(160,8,185,13);
group_color_view = new ColGrpView(raaa);
group_color_view->SetViewColor(0,255,0);
group_color_view->the_win = grpwin;

raaa.InsetBy(0,1.5);
raaa.OffsetBy(0,11);

group_ori_color_view = new ColGrpView(raaa);
group_ori_color_view->SetViewColor(255,255,0);
group_ori_color_view->the_win = grporiwin;


back_view->AddChild(group_color_view);
back_view->AddChild(group_ori_color_view);

//-------------------------------------------------------------


#define INF_TOP_TXT 0
#define INDENT 2 //bord gauche
#define BAR_INDENT 8 //bord gauche

unsigned char line_pos=0;
line_pos=4;


rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
pop_view = new TxtView(rect, "pop", "xxx");
AddChild(pop_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
money_view = new TxtView(rect, "money", "xxx");
AddChild(money_view);

line_pos++;
line_pos++;
rect.Set(BAR_INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-BAR_INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT-6);
moral_bar = new BarView(rect, "Moral",35," (Revolution Near!)"); //la rev est à 25
AddChild(moral_bar);

line_pos++;
rect.OffsetBy(0,16);
resist_bar = new BarView(rect, "Resistance",0," (free)");
AddChild(resist_bar);

line_pos++;
rect.OffsetBy(0,24);
agri_bar = new BarView(rect, "Agriculture",STARVE_LEVEL, " (starving!)");
AddChild(agri_bar);
    
line_pos++;
rect.OffsetBy(0,15);
indus_bar = new BarView(rect, "Industry",0,""); //pas de limite
AddChild(indus_bar);


///

line_pos++;
line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
tl_view = new TxtView(rect, "tech_level", "xxx");
AddChild(tl_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
infantry_view = new TxtView(rect, "infantry", "xxx");
AddChild(infantry_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
tank_view = new TxtView(rect, "tank", "xxx");
AddChild(tank_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
marine_view = new TxtView(rect, "marine", "xxx");
AddChild(marine_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
airforce_view = new TxtView(rect, "airforce", "xxx");
AddChild(airforce_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
dca_view = new TxtView(rect, "dca", "xxx");
AddChild(dca_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
missile_view = new TxtView(rect, "missile", "xxx");
AddChild(missile_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
nuke_view = new TxtView(rect, "nuke", "xxx");
AddChild(nuke_view);



///-------------------------------------------


line_pos++;
line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
engaged_view = new TxtView(rect, "eng1", "...");
AddChild(engaged_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
engaged2_view = new TxtView(rect, "eng2", "...");
AddChild(engaged2_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
engaged3_view = new TxtView(rect, "eng3", "...");
AddChild(engaged3_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
engaged4_view = new TxtView(rect, "eng4", "...");
AddChild(engaged4_view);

///

line_pos++;
line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
ennemy_view = new TxtView(rect, "enmy", "...");
AddChild(ennemy_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
ennemy2_view = new TxtView(rect, "enmy", "...");
AddChild(ennemy2_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
ennemy3_view = new TxtView(rect, "enmy", "...");
AddChild(ennemy3_view);

line_pos++;
rect.Set(INDENT,INF_TOP_TXT+(jour->interligne*line_pos),INFO_X_SIZE-1-INDENT, (jour->interligne*(line_pos+1)) + INF_TOP_TXT);
ennemy4_view = new TxtView(rect, "enmy", "...");
AddChild(ennemy4_view);



		

UpdateCountryInfo();

}


//------------------------------------------------------------

InfoView::~InfoView()
{
}

//------------------------------------------------------------

void InfoView::MouseDown(BPoint point)
{

if (jour->edit_mode==ON && point.y<80) 
	{

		ColorWindow *colWindow = new ColorWindow(Grp_pointer[Ct_pointer[jour->active_country]->group],jour);
	    colWindow ->Lock();	
	    colWindow ->Show();	
	    colWindow ->Unlock();	
	}

}


//--------------------------------------

void InfoView::UpdateCountryInfo()
{

	const char *tmp;
	
	int grp,base_grp;
	grp = Ct_pointer[jour->active_country]->group; //trouve le groupe à qui appartient le pays
	base_grp = Ct_pointer[jour->active_country]->base_group;
	
	rgb_color couleur_groupe = Grp_pointer[grp]->grp_color;
	rgb_color couleur_ori_groupe = Grp_pointer[base_grp]->grp_color;

	char str[255];
	char str2[255];
	
	sprintf(str,Ct_pointer[jour->active_country]->name);

	//day !=month_counter (day=nb total de jour)
	strcat(str," (");
	sprintf(str2,jour->month_name);  	strcat(str,str2);
	sprintf(str2," %i, %i",jour->month_counter, jour->year);	strcat(str,str2);
	strcat(str,")");
	Window()->SetTitle(str);

	
	//A l'ancienne
	
	//------------------------

	if (grpwin!=NULL) grpwin->grp_view->UpdateGroupInfo(Ct_pointer[jour->active_country]->group);
	if (grporiwin!=NULL) grporiwin->grp_view->UpdateGroupInfo(Ct_pointer[jour->active_country]->base_group);
	group_color_view->SetViewColor(couleur_groupe);
	group_color_view->Invalidate();
    
    group_ori_color_view->SetViewColor(couleur_ori_groupe);
	group_ori_color_view->Invalidate();
    
//ON ACCEDE AUX PAYS qu'à partir de leur numero dans le tableau
//IDEM POUR LES GROUPES


	

	
	//POPULATION pas de virgule en %i
	sprintf(str,"Population: %llu",Ct_pointer[jour->active_country]->population);
	pop_view->SetText(str);

	moral_bar->percentage = Ct_pointer[jour->active_country]->moral;
	resist_bar->percentage = Ct_pointer[jour->active_country]->resistance;
	agri_bar->percentage = Ct_pointer[jour->active_country]->agriculture;
	indus_bar->percentage = Ct_pointer[jour->active_country]->industry;

	moral_bar->Invalidate();
	resist_bar->Invalidate();
	agri_bar->Invalidate();
	indus_bar->Invalidate();

	
	
	//Money si le chiffre  %g pour les flottants, %i pour les entiers
	sprintf(str,"$ %lu mio.",Ct_pointer[jour->active_country]->money);
	sprintf(str2,"   Tax: %.4g %%",Ct_pointer[jour->active_country]->tax);
	tmp=strcat(str,str2); //on joint les deux bouts après car types différents
	money_view->SetText(tmp);
	
	//tl_view->SetAlignment(B_ALIGN_LEFT);	
	//Tech_Level	
	sprintf(str,"Tech level: %.4g %% (%.4g %%)",
				Ct_pointer[jour->active_country]->tech_level,
				Ct_pointer[jour->active_country]->ennemy_tech_level);
	tmp=str;
	tl_view->SetText(tmp);

	//Infantry	
	sprintf(str,"Infantry: %lu (%lu)",Ct_pointer[jour->active_country]->infantry,Ct_pointer[jour->active_country]->ennemy_infantry);
	tmp=str;
	infantry_view->SetText(tmp);

	//Tank	
	sprintf(str,"Tank: %u (%lu)",Ct_pointer[jour->active_country]->tank,Ct_pointer[jour->active_country]->ennemy_tank);
	tmp=str;
	tank_view->SetText(tmp);

	//Marine	
	sprintf(str,"Marine: %u (%lu)",Ct_pointer[jour->active_country]->marine,Ct_pointer[jour->active_country]->ennemy_marine);
	tmp=str;
	marine_view->SetText(tmp);

	//Airforce
	sprintf(str,"Airforce: %u (%lu)",Ct_pointer[jour->active_country]->airforce,Ct_pointer[jour->active_country]->ennemy_airforce);
	tmp=str;
	airforce_view->SetText(tmp);
		
	//Missile
	sprintf(str,"Missile: %u (%lu)",Ct_pointer[jour->active_country]->missile,Ct_pointer[jour->active_country]->ennemy_missile);
	tmp=str;
	missile_view->SetText(tmp);	
	
	//DCA
	sprintf(str,"DCA: %i (-)",Ct_pointer[jour->active_country]->dca);
	tmp=str;
	dca_view->SetText(tmp);
	
	//Nuke
	sprintf(str,"Nuke: %i (%lu)",Ct_pointer[jour->active_country]->nuke,Ct_pointer[jour->active_country]->ennemy_nuke);
	tmp=str;
	nuke_view->SetText(tmp);




	//Engaged 1
	sprintf(str," ");//par défaut rien
	engaged_view->SetHighColor(255,255,255,0); 
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->victim_01!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->victim_01->group]->grp_color;
	engaged_view->SetHighColor(col); 
		
		sprintf(str,"Attacking "); //partons du principe qu'on attaque un ennemi
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->victim_01->group)
		{sprintf(str,"Moving to ");}
		strcat(str,Ct_pointer[jour->active_country]->victim_01->name);
		sprintf(str2," in %d day(s)",Ct_pointer[jour->active_country]->travel_01);
		if (Ct_pointer[jour->active_country]->move_01!=OFF)strcat(str,str2);
	}
	engaged_view->SetText(str);

	//Engaged 2
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->victim_02!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->victim_02->group]->grp_color;
    	engaged2_view->SetHighColor(col); 

		sprintf(str,"Attacking "); //partons du principe qu'on attaque un ennemi
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->victim_02->group)
		{sprintf(str,"Moving to ");}

		strcat(str,Ct_pointer[jour->active_country]->victim_02->name);
		sprintf(str2," in %d day(s)",Ct_pointer[jour->active_country]->travel_02);
		if (Ct_pointer[jour->active_country]->move_02!=OFF)strcat(str,str2);
		}
	engaged2_view->SetText(str);



	//Engaged 3
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->victim_03!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->victim_03->group]->grp_color;
	engaged2_view->SetHighColor(col); 

		sprintf(str,"Attacking "); //partons du principe qu'on attaque un ennemi
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->victim_03->group)
		{sprintf(str,"Moving to ");}

		strcat(str,Ct_pointer[jour->active_country]->victim_03->name);
		sprintf(str2," in %d day(s)",Ct_pointer[jour->active_country]->travel_03);
		if (Ct_pointer[jour->active_country]->move_03!=OFF)strcat(str,str2);
	}
	engaged3_view->SetText(str);


	//Engaged 4
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->victim_04!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->victim_04->group]->grp_color;
	engaged4_view->SetHighColor(col); 

		sprintf(str,"Attacking "); //partons du principe qu'on attaque un ennemi
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->victim_04->group)
		{sprintf(str,"Moving to ");}

		strcat(str,Ct_pointer[jour->active_country]->victim_04->name);
		sprintf(str2," in %d day(s)",Ct_pointer[jour->active_country]->travel_04);
		if (Ct_pointer[jour->active_country]->move_04!=OFF)strcat(str,str2);
	}
	engaged4_view->SetText(str);
	

	//Ennemy 1
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->agressor_01!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->agressor_01->group]->grp_color;
	ennemy_view->SetHighColor(col); 
		sprintf(str,"Attacked by "); 
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->agressor_01->group)
		{sprintf(str,"Moving from ");}
	 	strcat(str,Ct_pointer[jour->active_country]->agressor_01->name);
		if(Ct_pointer[jour->active_country]==Ct_pointer[jour->active_country]->agressor_01)
		sprintf(str,"Attacked by resistance!");     
	}
	ennemy_view->SetText(str);

	//Ennemy 2
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->agressor_02!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->agressor_02->group]->grp_color;
	ennemy2_view->SetHighColor(col); 
		sprintf(str,"Attacked by "); 
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->agressor_02->group)
		{sprintf(str,"Moving from ");}
	 	strcat(str,Ct_pointer[jour->active_country]->agressor_02->name);
		if(Ct_pointer[jour->active_country]==Ct_pointer[jour->active_country]->agressor_02)
		sprintf(str,"Attacked by resistance!");     
	}
	ennemy2_view->SetText(str);

	//Ennemy 3
	sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->agressor_03!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->agressor_03->group]->grp_color;
	ennemy3_view->SetHighColor(col); 
		sprintf(str,"Attacked by "); 
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->agressor_03->group)
		{sprintf(str,"Moving from ");}
	 	strcat(str,Ct_pointer[jour->active_country]->agressor_02->name);
		if(Ct_pointer[jour->active_country]==Ct_pointer[jour->active_country]->agressor_03)
		sprintf(str,"Attacked by resistance!");     
 
	}
	ennemy3_view->SetText(str);

	//Ennemy 4
		sprintf(str," ");//par défaut rien
	//mais si il y a une victime...
	if(Ct_pointer[jour->active_country]->agressor_04!=NULL)
	{rgb_color col;
	 col=Grp_pointer[Ct_pointer[jour->active_country]->agressor_04->group]->grp_color;
	ennemy4_view->SetHighColor(col); 
		sprintf(str,"Attacked by "); 
		if (Ct_pointer[jour->active_country]->group==Ct_pointer[jour->active_country]->agressor_04->group)
		{sprintf(str,"Moving from ");}
	 	strcat(str,Ct_pointer[jour->active_country]->agressor_04->name);
		if(Ct_pointer[jour->active_country]==Ct_pointer[jour->active_country]->agressor_04)
		sprintf(str,"Attacked by resistance!");     
 
	}
	ennemy4_view->SetText(str);

//desactive les boutons pour les autres pays
if (Grp_pointer[Ct_pointer[jour->active_country]->group]->player==COMPUTER)
	{
		set_button->SetEnabled(false);
		buy_button->SetEnabled(false);	
	}
	
	else {
		set_button->SetEnabled(true);
		buy_button->SetEnabled(true);
		}
	


stat_view->Invalidate(); //pour le war-peace et autres		
wth_view->Invalidate(); //pour le war-peace et autres		


}//FIN FONCTION
	
	
//----------------------------------------------------------------------
//----------------------------------------------------------------------
//----------------------------------------------------------------------



//----------------------------------------------
//----------------------------------------------
GroupWindow::GroupWindow(BRect frame,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(frame, "Group Infos", B_BORDERED_WINDOW, B_NOT_ZOOMABLE | B_NOT_CLOSABLE | B_NOT_RESIZABLE | B_ASYNCHRONOUS_CONTROLS | B_NO_BORDER) 
{
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id; 
	Pol_pointer = Politic_id;
	
	jour->info_win_exists = ON;
	
//-------------------------------------
	grp_view = new GroupView(Bounds(), Ct_pointer,Grp_pointer,Pol_pointer,compteur);
	AddChild(grp_view); 
	
	SetFeel(B_FLOATING_APP_WINDOW_FEEL);
}




InfoWindow::InfoWindow(BRect frame,Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],Politic *Politic_id[MAX_POLITIC], day *compteur)
				: BWindow(frame, "Country Infos", B_FLOATING_WINDOW, B_NOT_ZOOMABLE | B_NOT_CLOSABLE | B_NOT_H_RESIZABLE | B_ASYNCHRONOUS_CONTROLS) 
{
	jour=compteur;
	Ct_pointer = Country_id;
	Grp_pointer = Group_id; 
	Pol_pointer = Politic_id;
	
	jour->info_win_exists = ON;
	
//-------------------------------------
	i_view = new InfoView(Bounds(), Ct_pointer,Grp_pointer,Pol_pointer,compteur);
	AddChild(i_view); 
	
	//on peut pas le faire à l'intérieur!!! donc après le addchild
	i_view->ChildAt(0)->SetViewBitmap(BTranslationUtils::GetBitmap('RAWT', 50, NULL));

	i_view->grpwin->Hide();
	i_view->grporiwin->Hide();
}

InfoWindow::~InfoWindow()
{
	jour->info_win_exists=OFF;
	//surtout pas faire un Close() ici! On est déjà en train de killer la win
}


void InfoWindow::MessageReceived(BMessage *message)
{

	// Print the message to see its contents
	//message->PrintToStream();

 	switch ( message->what )
 	{
 	
 		case BUTTON_BUY: 	jour->mainWin->PostMessage(BUTTON_BUY);	break;
 		case BUTTON_SET: 	jour->mainWin->PostMessage(BUTTON_SET);	break;
 		
		case DRAW_INFO:
		i_view->UpdateCountryInfo();
		jour->mainWin->PostMessage(UPDATE_POWER_BAR);
		break;
		
		default:
   		// Call inherited if we didn't handle the message
   		BWindow::MessageReceived(message);
        break;
		}//end switch

}//fin message received


void InfoView::CreateButton(int32 enabled_id ,int32 disabled_id)
{
			
//			BWindow *tmp_win = new BWindow(BRect(0,0,32,32),"",B_DOCUMENT_WINDOW,Flags(),B_CURRENT_WORKSPACE);
			
			//fill bitmap
			downBitmap = BTranslationUtils::GetBitmap('RAWT', enabled_id, NULL);
			upBitmap = BTranslationUtils::GetBitmap('RAWT', disabled_id, NULL);
			
			//avoid crash if missing
			if (downBitmap==NULL) downBitmap = new BBitmap(BRect(0,0,15,15),B_RGB32);
			if (upBitmap==NULL) upBitmap = new BBitmap(BRect(0,0,15,15),B_RGB32);
			
			BRect rect = downBitmap->Bounds();

			//Faut un window pour le faire
			BWindow* x= new BWindow(rect,"", B_FLOATING_WINDOW, Flags(), B_CURRENT_WORKSPACE);
			
			//tempview for creating the picture
			BView *tempView = new BView( rect, "temp", B_FOLLOW_NONE, B_WILL_DRAW );
			x->AddChild(tempView);
			
			//create on picture
   			tempView->BeginPicture(new BPicture); 
   			tempView->DrawBitmap(upBitmap);
   			on = tempView->EndPicture();
   			//create off picture
   			tempView->BeginPicture(new BPicture); 
   			tempView->DrawBitmap(downBitmap);
   			off = tempView->EndPicture();
   			//get rid of tempview
   			
   			x->RemoveChild(tempView);
   			x->Close();
			delete upBitmap;
   			delete downBitmap;
   			
}

