#ifndef INF_WINDW_H
#define INF_WINDW_H

#include "def_col.h"
#include "day.h"
#include "country.h"
#include "PopWindow.h"
#include <TranslationUtils.h>
#include <PictureButton.h>

//-----------------------------------------
//-----------------------------------------

class TxtView : public BStringView 
{ 
	public: 
	TxtView(BRect frame, const char *name, const char *text);  
};

class	BarView : public BView {
public:
		BarView(BRect r,const char *name,float limit, const char* limit_text);
		char name[255];
		char limit_text[255];
		virtual	void Draw(BRect);
		float percentage,limit;
};


class	ColGrpView : public BView {
public:
		ColGrpView(BRect r);
		virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
		BWindow *the_win;
		bool hidden;		
		
};

class	StatusView : public BView {
public:
		StatusView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
			 		Politic *Politic_id[MAX_POLITIC], day *compteur);

virtual	void		Draw(BRect);

		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic **Pol_pointer;				
		
		BBitmap *img_war, *img_peace;

};


class	WeatherView : public BView {
public:
		WeatherView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
			 		Politic *Politic_id[MAX_POLITIC], day *compteur);

virtual	void		Draw(BRect);

		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic **Pol_pointer;				
		
		BBitmap *img_very_dry, *img_dry, *img_normal_hum, *img_rainy, *img_very_rainy;
		BBitmap *img_very_cold, *img_cold, *img_normal_temp, *img_hot, *img_very_hot;
		
};

class	TopView : public BView {
public:
		TopView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
			 		Politic *Politic_id[MAX_POLITIC], day *compteur);

//virtual	void		Draw(BRect);

		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic **Pol_pointer;				
};


class	GroupView : public BView {
public:
	
		GroupView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
			 		Politic *Politic_id[MAX_POLITIC], day *compteur);

		day		*jour;
		Country **Ct_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Group   **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Politic **Pol_pointer;	 //utilisé par les sous-fonctions type MouseDown

virtual	void		Draw(BRect);
//virtual		void		MouseDown(BPoint where);

		TxtView *grp_name_view,*player_view;
		
		uint8 grp;
void	UpdateGroupInfo(uint8 which_grp);

};

class GroupWindow : public BWindow 
{
public:
		
		GroupWindow(BRect frame, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP], 
							Politic *Politic_id [MAX_POLITIC], day *compteur);


		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic **Pol_pointer;				
		
		GroupView	*grp_view; 

};

//-------------------------------------------------------------------
//-------------------------------------------------------------------
class	InfoView : public BView {
public:
		float		size_x,size_y;	
	
		InfoView(BRect r, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP],
				 		Politic *Politic_id[MAX_POLITIC], day *compteur);
virtual	~InfoView();

void		MouseDown(BPoint where);

	
		day		*jour;
		Country **Ct_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Group   **Grp_pointer;	 //utilisé par les sous-fonctions type MouseDown
		Politic **Pol_pointer;	 //utilisé par les sous-fonctions type MouseDown

void	UpdateCountryInfo();

	ColGrpView* group_color_view;
	ColGrpView* group_ori_color_view;

	
	TopView *back_view; 
	
	TxtView	*pop_view,*money_view;
	
	BarView *moral_bar, *resist_bar, *agri_bar,*indus_bar;
	
	TxtView *tl_view; //techlevel
	
	TxtView *infantry_view, *tank_view, *marine_view;
	TxtView	*airforce_view, *dca_view, *missile_view,*nuke_view;

	TxtView *engaged_view,*engaged2_view,*engaged3_view,*engaged4_view;
	TxtView *ennemy_view,*ennemy2_view,*ennemy3_view,*ennemy4_view;
//-------------------------------------------------------------

void CreateButton(int32 enabled_id ,int32 disabled_id);

	BBitmap* downBitmap;
	BBitmap* upBitmap;
   	BPicture *on,*off;
   	
   	BPictureButton *buy_button, *set_button;
   	GroupWindow *grpwin,*grporiwin;
   	
   	WeatherView *wth_view;
   	StatusView *stat_view;
};


class InfoWindow : public BWindow 
{
public:
		
		InfoWindow(BRect frame, Country *Country_id[MAX_COUNTRY],Group *Group_id[MAX_GROUP], 
							Politic *Politic_id [MAX_POLITIC], day *compteur);
virtual	~InfoWindow();

virtual void 	MessageReceived(BMessage *message);

		day		*jour;
		Country **Ct_pointer;	 
		Group	**Grp_pointer;
		Politic **Pol_pointer;				
		
		InfoView	*i_view; 

};




#endif