#ifndef COUNTRY_H
#define COUNTRY_H
#include "def_col.h"

//*************************************//
//********* Classe Country.H ************//
//*************************************//

#define FREE      0
#define OCCUPIED  1
#define RESISTANCE_TECH_LEVEL  25  //en pourcents
#define MAX_RESISTANCE         15  //en pourcents de l'infanterie ennemie


#define REVOLUTION_EUPHORY 150  //nb jours avant risque nouvelle révolution si agric augmente pas assez

#define COST_INFANTRY 0.01             //en millions!!!
#define COST_TANK     6
#define COST_MARINE   100
#define COST_AIRFORCE 15
#define COST_MISSILE  50      //le missile est pas cher car il s'utilise qu'une fois
#define COST_DCA      5
#define COST_NUKE     50

#define MEN_PER_INFANTRY 1     //nb hommes par unite militaire (inf=1 of course)
#define MEN_PER_TANK     3    //faut du monde pour faire marcher ca...
#define MEN_PER_MARINE   200   //pour soustraire la populace
#define MEN_PER_AIRFORCE 5     //un pilote et 4 logistique...
#define MEN_PER_MISSILE  10    //faut du monde pour faire marcher ca...
#define MEN_PER_DCA      7     //faut du monde pour faire marcher ca...
#define MEN_PER_NUKE     25     //faut du monde pour faire marcher ca...

#define STRENGTH_INFANTRY 1    //FORCE par rapport a une unit d'infanterie (infanterie =toujours 1 of course...)
#define STRENGTH_TANK     40
#define STRENGTH_MARINE   350
#define STRENGTH_AIRFORCE 120
#define STRENGTH_MISSILE  250
#define STRENGTH_DCA      250

#define MISSILE_POWER     10    //nb de fois qu'on multiplie le kill de l'autre
                                //le missile est hyperpuissants mais disparait au bout d'un jour
#define MISSILE_PER_DAY   10    //nb de missiles lances par jour
#define NUKE_PER_DAY      10    //nb max de bombes A par jour
//pas de strength nuke...

#define KM_PER_PIXEL   35 //pour image.cc
                          //voir pour etre plus precis

#include "day.h"

#define LOST    0
#define WON     1

#define DEFAULT_ARMY_TAX     10     //en pourcents du PNB qui va pour l'armee
#define DEFAULT_BIRTH_RATE   1.5
#define DEFAULT_YEAR         1970  //c'est l'age de mes statistiques
#define KILOMETER_PER_DAY    1000

#define INFANTRY 0   //UTILISE par fonction buy
#define TANK     1
#define MARINE   2
#define AIRFORCE 3
#define MISSILE  4
#define DCA      5
#define NUKE     6

#define KILL_INFANTRY 1500     //morts par jour pour bataille ratio 1 contre 1
#define KILL_TANK     10
#define KILL_MARINE   0.5
#define KILL_AIRFORCE 2
#define KILL_MISSILE  2
#define KILL_DCA      8

#define KILL_INDUSTRY    0.05    //pourcentage de l'industrie perdue par attaque
#define KILL_AGRICULTURE 0.03    //a multiplier par le tech_level de l'autre
#define KILL_POPULATION  500
#define KILL_POPULATION_NUKE     50000   //par bombe pas abbatue par la dca voire plus
#define KILL_INDUSTRY_NUKE       1.5       //en pourcents par bombe

#define MIN_AGRICULTURE 25         //minimum possible
#define MIN_INDUSTRY    25
#define MIN_MORAL       25
#define MIN_TECH_LEVEL  5

#define STARVE_LEVEL  35                  //si agriculture trop bas en pourcents... morts de faim
#define STARVE_AMOUNT 0.00001                 // pourcents de population morts de faim par jour
#define RECOVERY_AGRICULTURE 0.021         //recuperation en pourcent par jour
#define RECOVERY_INDUSTRY    0.02         //ca devrait etre pas moins que
                                          //kILL_INDUSTRY et KILL_AGRI


//pour agriculture-temps
#define VERY_DRY        1
#define DRY             2
#define MODERATE        3
#define RAINY           4
#define VERY_RAINY      5

#define VERY_COLD       1
#define COLD            2
// #define MODERATE     3 //meme moderate pour secheresse et temperature
#define WARM            4
#define HOT             5

#define WEATHER_INFLUENCE 0.6  // nb de fois qu'on multiplie la difference
                                // pour obtenir les pourcents a soustraire de l'agriculture
                                // par mois
#include "group.h"
#include "weapon.h"

class Attack: public BArchivable 
{
public:
   Attack(uint8 which_to_attack, uint16 days_before);
   Attack(BMessage *archive);
   
   uint64 attack_army[MAX_WEAPON];
   uint8 victim_id;
   uint16 days_before_attack;
   bool fighting;
   //on fait le setarmy après la création dans une boucle
   void SetArmy(uint8 which_type, uint64 amount);
   
};


class Country: public BArchivable //faut dériver de BArchivable pour pouvoir etre archivé (sauvé sur HD)
{

public:
//CREATORs
Country(char ct_name[255],char couleur_num,char group, day *compteur,Group *Group_id[MAX_GROUP], Country *Country_id[MAX_COUNTRY],Politic *Politic_id[MAX_POLITIC],Weapon *Weapon_id[MAX_WEAPON]); 	// col_dans pal + groupe
Country(BMessage *archive);
BArchivable *Country::Instantiate(BMessage *archive); 


//BArchivable *Country::Instantiate(BMessage *archive);

Group	**Grp_pointer;
Country	**Ct_pointer;
Politic	**Pol_pointer;
Weapon	**Wpn_pointer;

day		*jour;   
   
   
   int16 attack_amount;
   int16 agression_amount;
   Attack* current_attacks[MAX_ATTACK];  
   Attack* current_agressions[MAX_ATTACK];  
   
   int16 TravelTime(Country* to_which_country);
   void AddAttack(uint8 victim_id);
   void AddAgressor(Attack* attack);
   
   uint64 the_army[MAX_WEAPON]; //max 24 armes sinon le tab multiplié par le nb de pays devient trop gros
							//déjà comme ça pour 200 pays on en a pour 384 k					
   uint64 the_ennemy_army[MAX_WEAPON];
   
   BRect limit;
   int status;
   int32 inf_def; 
   int32 tnk_def, mar_def, air_def, mis_def,dca_def,nuke_def;
   unsigned char attacked_by;
   float center_x,center_y;
   int16 travel_01,travel_02,travel_03,travel_04;
   unsigned char move_01,move_02,move_03,move_04;
   unsigned char month_changed,access_sea,access_nuke;
   unsigned char real_temperature,expected_temperature;  //cold or hot
   unsigned char real_weather,expected_weather;          //dry ou rainy
 

   
   void PowerCalc();
   void GroupPower();
   void CheckUp();
   
   uint32 money;
   char name[255];
   uint32 power;
   Country *victim_01,*victim_02,*victim_03,*victim_04; //pays_attackes
   Country *agressor_01,*agressor_02,*agressor_03,*agressor_04; //agresseurs presents
   uint64 population;
   int16 defeat,victory,war,civ_killed,pnb;
   double moral,birth_rate,tech_level,ennemy_tech_level,tax; // moral,birth ou tech en % donc avec virgule
   double agriculture, industry, resistance,resist_counter;
   int marine, airforce, missile,dca,tank,nuke;

   int32 inf_01, tnk_01, mar_01, air_01, mis_01, nuke_01; //troupes engagees
   int32 inf_02, tnk_02, mar_02, air_02, mis_02, nuke_02; //ou en route
   int32 inf_03, tnk_03, mar_03, air_03, mis_03, nuke_03;
   int32 inf_04, tnk_04, mar_04, air_04, mis_04, nuke_04;

   int32 infantry, ennemy_infantry;
   int32 ennemy_marine, ennemy_airforce,ennemy_missile,ennemy_tank,ennemy_nuke;
   unsigned char fight_marine,fight_infantry, fight_airforce, fight_missile, fight_dca,fight_tank;
   unsigned char fight_ennemy_marine, fight_ennemy_tank, fight_ennemy_infantry, fight_ennemy_airforce, fight_ennemy_missile,fight_ennemy_nuke;
   //pas de fight_nuke, seulement fight_ennemy_nuke

  	unsigned char nb_in_pal,battle_turn;
    unsigned char group,base_group; //numero du groupe politique

   void set_group(unsigned char); 	//changement de groupe (conquête)
   //void show_info(); //affiche les infos du pays
   
   //Ca c'est les nouvelles fonctions pour l'armée...
   void AddArmy(uint8 which_type, bool to_ennemy, uint64 amount);
   void SubArmy(uint8 which_type, bool to_ennemy, uint64 amount);
   void SetArmy(uint8 which_type, bool to_ennemy, uint64 amount);
   bool BuyArmy(uint8 which_type, uint64 amount);
   
   void SendTroops(Country *victim, uint8 attack_id);
   void IsAttacking(Country *victim,uint8 attack_id);
   void IsAttacked(Country *agressor,uint8 attack_id);
   void AskRetreat(Country *home_country);
   
   ///---------------------------------------------------------------------------------------
   
   
   void add_population(unsigned long);     void sub_population(unsigned long);     void set_population(unsigned long);
   void add_pnb(int);            void sub_pnb(int);            void set_pnb(int);
   void add_civ_killed(int);     void sub_civ_killed(int);     void set_civ_killed(int);
   void add_birth_rate(double);  void sub_birth_rate(double);  void set_birth_rate(double);
   void add_tax(double);         void sub_tax(double);         void set_tax(double);
   void add_moral(double);       void sub_moral(double);       void set_moral(double);
   void add_tech_level(double);  void sub_tech_level(double);  void set_tech_level(double);
   void add_money(float);        void sub_money(float);        void set_money(float);
   void add_agriculture(double); void sub_agriculture(double); void set_agriculture(double);
   void add_industry(double);    void sub_industry(double);    void set_industry(double);

   void add_infantry(long);     void sub_infantry(long);  void set_infantry(long);
   void add_tank(int);         void sub_tank(int);        void set_tank(int);
   void add_marine(int);       void sub_marine(int);      void set_marine(int);
   void add_airforce(int);     void sub_airforce(int);    void set_airforce(int);
   void add_missile(int);      void sub_missile(int);     void set_missile(int);
   void add_dca(int);          void sub_dca(int);         void set_dca(int);
   void add_nuke(int);         void sub_nuke(int);        void set_nuke(int);

   void add_ennemy_marine(int);       void sub_ennemy_marine(int);      void set_ennemy_marine(int);
   void add_ennemy_infantry(long);     void sub_ennemy_infantry(long);    void set_ennemy_infantry(long);
   void add_ennemy_tank(int);         void sub_ennemy_tank(int);        void set_ennemy_tank(int);
   void add_ennemy_airforce(int);     void sub_ennemy_airforce(int);    void set_ennemy_airforce(int);
   void add_ennemy_missile(int);      void sub_ennemy_missile(int);     void set_ennemy_missile(int);
   void add_ennemy_nuke(int);         void sub_ennemy_nuke(int);        void set_ennemy_nuke(int);

   void set_army(); //génére les valeurs par défaut
   void default_army(); //applique les valeurs par défaut
   void add_victory(int);    void sub_victory(int);    void set_victory(int);
   void add_defeat(int);     void sub_defeat(int);     void set_defeat(int);

   bool buy(long inf_xx,int tank_xx,int mar_xx,
   					int air_xx,int mis_xx,int nuke_xx,int dca_xx); 

   void day_passed();   //chaque fois qu'un jour passe, industry etc...
   void month_passed();   //chaque fois qu'un jour passe, industry etc...

   void day_passed_fake();     //juste pour l'avance du debut...
   void month_passed_fake();   //ces deux n'agissent que sur la population


   void send_troops(Country *victim, long sent_inf, int sent_tnk, int sent_mar,
                        int sent_air, int sent_mis, int sent_nuke); //envoi des troupes
   void attacking(Country *victim, long engaged_inf, int engaged_tnk, int engaged_mar,
                        int engaged_air, int engaged_mis, int engaged_nuke); //engagement des troupes
   void attacked(Country *agressor,
                       long en_infantry, int en_tank, int en_marine,
                       int en_airforce, int en_missile, int en_nuke,
                       unsigned char attacking_group, double en_tech); //attaque par ennemi
  
   void Retreat(Country *home_country);
   unsigned char battle(); //action de bataille
   void Revolution();
   unsigned char revolution_happened;
   int revolution_euphory; //nb de jour que dure l'euphorie avant de risquer nouvelle revolution
  
   void ComputerPlay();
   int FindDistance(Country *ct1,Country *ct2);//distance en km
   }; //fin de declaration classe Country


#endif
